import json
import os
from unittest import TestCase

import click
from click.testing import CliRunner

from top40 import display, _get_charts


class Top40DisplayTest(TestCase):
    """Basic Top 40 Display TestCase"""

    def setUp(self):
        self.runner = CliRunner()
        self.path = os.path.dirname(__file__)

    def test_top40_display_can_be_called_without_params(self):
        result = self.runner.invoke(display)

        self.assertEqual(result.exit_code,  0)

    def test_top40_display_prints_default_options(self):
        response = open(self.path + '/fixtures/response.json')
        res = json.load(response)
        _get_charts = res['entries']

        result = self.runner.invoke(display)

        self.assertEqual(len(result.output.splitlines()), 10)
        self.assertEqual(result.output.splitlines()[0], "1. {} - {}".format(
            _get_charts['title'], _get_charts['artist']))



if __name__ == '__main__':
    unittest.main()